



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>org.hibernate.PersistentObjectException: detached entity passed to persist</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">org.hibernate.PersistentObjectException: detached entity passed to persist</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 10:48:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>简单地来看，将一个游离的对象要被持久化(save)时报错。&nbsp;<br />我们知道要持久化对象时候，通常Hibernate会根据ID生成策略自动生成ID值，但是这个对象ID已经有值，所有抛错。这个错误会出现在配置如下一对多@OneToMany的关联关系等出现。</p>
<div>
<pre class="prettyprint linenums">// 部门拥有的车辆<br />
    @OneToMany(cascade = CascadeType.ALL, fetch = FetchType.LAZY, mappedBy = "assignedDept")<br />
    @JsonIgnore<br />
    private List&lt;Vehicle&gt; assignedVehicles;</pre>
</div>
<p>因为级联关系是CascadeType.ALL，所以save时会保存级联的对象Role，但是Role已经存在，因此就报错了。将cascade改为CascadeType.MERGE或者CascadeType.REFRESH即可，表示级联对象在Role表存在则进行update操作，而不做save操作。<strong>级联操作时谨慎用CascadeType.ALL</strong></p>
<p><strong>改为：</strong></p>
<div>
<pre class="prettyprint linenums">@OneToMany(cascade = CascadeType.REFRESH, fetch = FetchType.LAZY, mappedBy = "assignedDept")</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q7mdkkq.html">codevs 2830 蓬莱山辉夜</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mj7k68.html">关于vs2012、tfs2012、windows server 2008r2一些记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jn6zg8.html">DELPHI XE5 与SQLITE</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwwwzyq.html">&lbrack;转&rsqb;&lbrack;译&rsqb;关于CSS中的float和position和z-index</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv5d4oq.html">夺命雷公狗---DEDECMS----28dedecms浏览次数的完成</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdwwg38.html">2016-3-25突然推送大量消息的问题及查找 -- Sangit</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1zz3x8.html">BestCoder 1st Anniversary</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memyjrq.html">基于内容的图像检索技（CBIR）术相术介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj1pvj8.html">C&num;的百度地图开发&lpar;三&rpar;依据坐标获取位置、商圈及周边信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj02ly8.html">玩转 SSH（六）：SpringMVC &plus; MyBatis 架构搭建（注解版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg1vw78.html">Ubuntu下Tomcat初始配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjpw4y8.html">java中&amp;lt&semi;&amp;gt&semi; 的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rglgdd8.html">poj 1696 叉积理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1g101q.html">leetcode算法题整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wx6rnq.html">离线安装expect</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv213lz9.html">PhoenixFD插件流体模拟&mdash;&mdash;UI布局【Splash &vert; Mist】详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvyzvg8.html">Linux驱动面试题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjgedr9.html">Codeforces Round &num;423 &lpar;Div&period; 2&comma; rated&comma; based on VK Cup Finals&rpar;  Problem A - B</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ppyrz8.html">【Miktex】使用教程以及数学符号整理总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vlpdzq.html">servlet练习1</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pdyx149.html">Linux中文件夹的文件按照时间倒序或者升序排列</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj2kee9.html">js处理时间戳显示的问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjkg528.html">笔记︱集成学习Ensemble Learning与树模型、Bagging 和 Boosting</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxkr6e08.html">利用Caffe训练模型&lpar;solver、deploy、train&lowbar;val&rpar;&plus;python使用已训练模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzrdve8.html">apache配置，禁止ip访问web站点</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1knd4z9.html">vxworks for x86读取bios时间的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zwj3k9.html">java&period;text&period;ParseException&colon; Unparseable date&colon; &amp;quot&semi;2015-06-09 hh&colon;56&colon;19&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jnv3x8.html">Flex报错之二</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpl4259.html">Errors running buider &amp;&num;39&semi;DeploymentBuilder&amp;&num;39&semi; on project &amp;&num;39&semi;HFMS&amp;&num;39&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1knndz9.html">angular路由操作中&amp;&num;39&semi;&num;&amp;&num;39&semi;字符的解决办法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
